#pragma once

#include "opensbi/opensbi.h"

namespace drivers {
namespace opensbi::srst {

    enum class ResetType : uint32_t {
        SHUTDOWN,
        COLD_REBOOT,
        WARM_REBOOT
        // 0x00000003 - 0xEFFFFFFF: Reserved
        // 0xF0000000 - 0xFFFFFFFF: Vendor specific
    };

    enum class ResetReason : uint32_t {
        NO_REASON,
        SYSTEM_FAILURE
        // 0x00000002 - 0xDFFFFFFF: Reserved
        // 0xE0000000 - 0xEFFFFFFF: SBI implimentation specific
        // 0xF0000000 - 0xFFFFFFFF: Vendor or platform specific
    };

    SbiRet system_reset(
            ResetType reset_type,
            ResetReason reset_reason);

}  // End namespace opensbi::srst
}  // End namespace drivers
