#include <stdint.h>

namespace drivers {
namespace sunxi_d1_pinctrl {

struct [[gnu::aligned(4)]] Port {
    uint32_t config[4];
    uint32_t data;
    uint32_t drive[4];
    uint32_t pull[2];
    uint32_t _;
};

struct [[gnu::aligned(4)]] PortInt {
    uint32_t config[4];
    uint32_t control;
    uint32_t status;
    uint32_t debounce;
    uint32_t _;
};

struct [[gnu::aligned(4)]] PIO {
    uint32_t mode;
    uint32_t control;
    uint32_t value;
    uint32_t voltage_select;
};

struct [[gnu::aligned(4)]] Registers {
    volatile Port ports[7];
    volatile uint32_t _[0x34];
    volatile PortInt interrupt[7];
    volatile uint32_t __[0x10];
    volatile PIO pio;
};

}  // End namespace sunxi_d1_pinctrl
}  // End namespace drivers
